
class Drawer
{
    // Class Member Variables. These are initialized at startup

    int arraySize;     // placeholder for drawer array size assigned in class def;
    int *arrPass;     // passes drawer array pointer between functions
    int drawerNumber; // keeps track of drawer number assigned in class def

    int arraySlot; // keeps track of slots in array (to let us cycle through array incrementally)
    int buttonCounter; // counts # times drawer is opened

    int fileNumber; // keeps track of current file playing

    // Constructor - creates a "Drawer" and initializes the member variables and state

  public:
    Drawer(int *arrPtr, int arrSz, int drwNum) // input
    {
      arrPass = arrPtr;
      arraySize = arrSz;
      drawerNumber = drwNum;
      buttonCounter = 0; // counts # times switch is triggered'

    }


/* allPlayedChecker: checks to see if all files in an array have been played. 
 * If they have, function triggers array shuffle - if not, does nothing 
 */
    void setFile(int fileNumber)
    {
        buttonCounter = fileNumber;
    }


    void allPlayedChecker()
    {
      buttonCounter++;
      Serial.print("number of files in array played:  ");
      Serial.println(buttonCounter);
      if  (buttonCounter % arraySize == 0) {
        shuffle();         // reshuffle file array if we get all the way through the file list
        buttonCounter = 0;     // reset buttonCounter to zero. NOTE: SEEMS TO ONLY SHUFFLE AFTER BUTTON IS RELEASED
      }
    }

    void shuffle()
    {
      int r;             // placeholder for drawer shuffle output

      for (int a = 0; a < arraySize; a++) {
        arrPass[a] = a;
      }

      for (int a = 0; a < arraySize; a++) {
        r = random(a, arraySize); // random from a to total array number included.
        int temp = arrPass[a];
        arrPass[a] = arrPass[r];
        arrPass[r] = temp;
      }
      Serial.print("SHUFFLED! New order: ");
      for (int a = 0; a < arraySize; a++) {

        Serial.print(arrPass[a] + 1);
        Serial.print(" ");
        if (a == (arraySize)) {
          Serial.println();
          // delay(500);
        }
      }
      Serial.println();
    }


    void play() {
      fileNumber = arrPass[buttonCounter] + 1; // remove this and increment in logic (main loop)
      sendCommand(CMD_PLAY_FOLDER_FILE, drawerNumber, fileNumber);
      //Uncomment for Debugging
      Serial.println("PLAYING");
      Serial.print("drawer: ");
      Serial.println(drawerNumber);
      Serial.print("file: ");
      Serial.println(fileNumber);
      playing = true;
    }



  void checkDone() {
      if (ansbuf[3] == 0x3d) {
 Serial.println("BANG");
 }
  }



}; // end of class



